<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # Video-Verzeichnis 1.1.0 RC 2 (class_videosharingservice.php, Created: 11/14/2008 15:49)
|| # -------------------------------------------------------------------- # ||
|| # Copyright 2007-2008 Julian Schuh. All Rights Reserved.
|| # This file may not be redistributed in whole or significant part.     # ||
|| # -------------------------------------------------------------------- # ||
|| # http://vbpoint.org/board/versioncheck.php?do=findrelease&vbversion=3-7&language=en&productid=videodirectory
|| ######################################################################## ||
\*==========================================================================*/

define('VSS_ERROR_CONNECTION', 1);
define('VSS_ERROR_RESPONSE', 2);
define('VSS_ERROR_SERVICELOGIN', 4);
define('VSS_ERROR_NOEMBEDING', 8);
define('VSS_ERROR_MEDIATYPE', 32);
define('VSS_ERROR_INVALID_MEDIA', 16);

/**
 * Class to Fetch Video Informations
 *
 * @package VideoDirectory
 */
class vB_VideoSharingService
{
	/**
	* Url to work with
	*
	* @var	Url
	*/
	var $url;

	/**
	* Name of the Service
	*
	* @var	string
	*/
	var $hostername;

	/**
	* Error-Code
	*
	* @var	int
	*/
	var $error;

	/**
	* ID of the rocessed Video
	*
	* @var	Video-ID
	*/
	var $video_id;

	/**
	* ID of the rocessed Video
	*
	* @var	Video-ID
	*/
	var $thumbnailpath;

	/**
	* Title of the Video
	*
	* @var	Video-Title
	*/
	var $videotitle;

	/**
	* Description of the Video
	*
	* @var	Video-Description
	*/
	var $videodescription;


	/**
	* Registry object for any options we need
	*
	* @var	vB_Registry
	*/
	var $registry;

	/**
	* Constructor. Checks if the registry object was passed correctly.
	*
	* @param	vB_Registry		vBulletin Registry
	*/
	function vB_VideoSharingService(&$registry)
	{
		if (is_object($registry))
		{
			$this->registry =& $registry;
		}
		else
		{
			trigger_error('Registry object is not an object', E_USER_ERROR);
		}
	}

	/**
	* Verifys, if url is a service the class works with
	*
	* @param	string		Url
	*
	* @return	bool		Is the url of the service the class works with?
	*/
	function verify_service(&$url)
	{
		return false;
	}

	function fetch_hoster_varname()
	{
		return $this->hostername;
	}

	/**
	* Fetchs the ID of the Video
	*
	* @return	string		VideoID
	*/
	function fetch_videoid()
	{
		return $this->video_id;
	}

	/**
	* Fetchs the Url of the Video
	*
	* @return	string		Video-Url
	*/
	function fetch_videourl()
	{
		return $this->url;
	}

	/**
	* Path to Thumbnail of the Video
	*
	* @param	type		desc
	*
	* @return	type		desc
	*/
	function fetch_thumbnailpath()
	{
		return trim($this->thumbnailpath);
	}

	/**
	* Checks the Video ID
	*
	* @return	bool		True, if Video ID is correct
	*/
	function verify_videoid()
	{
		return true;
	}

	/**
	* Prepares the Data recieved from the Service
	*
	* @return	bool		True, if data could be prepared
	*/
	function prepare_data()
	{
		return false;
	}

	/**
	* Fetches the Discription of the video of the service
	*
	* @return	string		Returns the Original Video Description
	*/
	function fetch_videodescription()
	{
		return $this->videodescription;
	}

	/**
	* Fetches the Title of the video
	*
	* @return	string		Returns the Origina Title of the video
	*/
	function fetch_videotitle()
	{
		return $this->videotitle;
	}

	function set_error($error)
	{
		$this->error = $error;
	}

	function fetch_error()
	{
		return $this->error;
	}

	function fetch_embedcode($videoid = '')
	{
		return false;
	}

	function fetch_videobbcode($videoid = '')
	{
		return false;
	}
}

/*======================================================================*\
|| ####################################################################
|| # $Date: 2008-10-07 23:45:43 +0200 (Di, 07. Okt 2008) $
|| # $Revision: 11 $
|| ####################################################################
\*======================================================================*/
?>